precision lowp float;

 varying highp vec2 textureCoordinate;
 varying highp vec2 textureCoordinate2;
 varying highp vec2 textureCoordinate3;

 uniform sampler2D inputImageTexture;//image
 uniform sampler2D inputImageTexture3;//filtered image

 uniform vec2 strokeGapInPixel;     //描边与边缘间距
 uniform vec2 strokeWidthInPixel;   //描边宽度
 uniform vec4 strokeColor;          //描边颜色
 uniform int strokeType;    //描边类型

 float alphaForStep(float step_x, float step_y, float weight) {
     float step_x45 = step_x * 0.7071;
     float step_y45 = step_y * 0.7071;

     vec4 v3_10 = texture2D(inputImageTexture, vec2(textureCoordinate.x, textureCoordinate.y+step_y));
     vec4 v3_11 = texture2D(inputImageTexture, vec2(textureCoordinate.x+step_x45, textureCoordinate.y+step_y45));
     vec4 v3_12 = texture2D(inputImageTexture, vec2(textureCoordinate.x+step_x, textureCoordinate.y));
     vec4 v3_13 = texture2D(inputImageTexture, vec2(textureCoordinate.x+step_x45, textureCoordinate.y-step_y45));
     vec4 v3_14 = texture2D(inputImageTexture, vec2(textureCoordinate.x, textureCoordinate.y-step_y));
     vec4 v3_15 = texture2D(inputImageTexture, vec2(textureCoordinate.x-step_x45, textureCoordinate.y-step_y45));
     vec4 v3_16 = texture2D(inputImageTexture, vec2(textureCoordinate.x-step_x, textureCoordinate.y));
     vec4 v3_17 = texture2D(inputImageTexture, vec2(textureCoordinate.x-step_x45, textureCoordinate.y+step_y45));

     float alpha = step(weight, v3_10.a+v3_11.a+v3_12.a+v3_13.a+v3_14.a+v3_15.a+v3_16.a+v3_17.a);
     return alpha;
 }
 float alphaForStep2(float step_x, float step_y, float weight) {
     float step_x45 = step_x * 0.7071;
     float step_y45 = step_y * 0.7071;

     vec4 v3_10 = texture2D(inputImageTexture3, vec2(textureCoordinate.x, textureCoordinate.y+step_y));
     vec4 v3_11 = texture2D(inputImageTexture3, vec2(textureCoordinate.x+step_x45, textureCoordinate.y+step_y45));
     vec4 v3_12 = texture2D(inputImageTexture3, vec2(textureCoordinate.x+step_x, textureCoordinate.y));
     vec4 v3_13 = texture2D(inputImageTexture3, vec2(textureCoordinate.x+step_x45, textureCoordinate.y-step_y45));
     vec4 v3_14 = texture2D(inputImageTexture3, vec2(textureCoordinate.x, textureCoordinate.y-step_y));
     vec4 v3_15 = texture2D(inputImageTexture3, vec2(textureCoordinate.x-step_x45, textureCoordinate.y-step_y45));
     vec4 v3_16 = texture2D(inputImageTexture3, vec2(textureCoordinate.x-step_x, textureCoordinate.y));
     vec4 v3_17 = texture2D(inputImageTexture3, vec2(textureCoordinate.x-step_x45, textureCoordinate.y+step_y45));

     float alpha = step(weight, v3_10.a+v3_11.a+v3_12.a+v3_13.a+v3_14.a+v3_15.a+v3_16.a+v3_17.a);
     return alpha;
 }

 void main()
 {
     vec4 v1 = texture2D(inputImageTexture, textureCoordinate);
     vec4 v3 = texture2D(inputImageTexture3, textureCoordinate3);

     float mask = v1.a;
     vec4 bg = vec4(0.0);
     mask = smoothstep(0.7, 0.9, v3.a);

     if (strokeType == 1) { //描边
         if (mask < 0.9) {
             //背景
             float x = strokeGapInPixel.x;
             float y = strokeGapInPixel.y;
             float innerAlpha = alphaForStep(x, y, 4.0);
             if (innerAlpha > 0.9) {
                 //gl_FragColor = v1;
                 if (v1.a < 0.9) {
                     gl_FragColor = strokeColor;
                 } else {
                     gl_FragColor = v1;
                 }
             }
             else {
                 x += strokeWidthInPixel.x;
                 y += strokeWidthInPixel.y;
                 float outterAlpha = alphaForStep2(x, y, 0.5);
                 if (outterAlpha > 0.9) {
                     gl_FragColor = strokeColor;
                 }
                 else {
                     gl_FragColor = bg;
                 }
             }
         }
         else {
             //前景
             //判断前景是否之前很低
             float mask2 = v1.a;
             if (mask2 < 0.9) {
                 gl_FragColor = strokeColor;
             } else {
                 gl_FragColor = v1;
             }
         }
     } else if (strokeType == 2) {  //外发光
         if (mask < 0.5) {
             if (mask < 0.01){
                 gl_FragColor = bg;
             } else {
                 gl_FragColor = vec4(strokeColor.rgb, mask * 2.0);
             }
         }
         else {
             //前景
             gl_FragColor = v1;
         }
     } else if (strokeType == 0) {  //羽化
         if (strokeWidthInPixel.x > 0.0) {
             gl_FragColor = v1;
         }
         else {
             gl_FragColor = mix(bg, v1, v1.a < 0.4?0.0:1.0);
         }
     } else if (strokeType >= 3){
         if (textureCoordinate3.x < 0.0 || textureCoordinate3.x > 1.0 || textureCoordinate3.y < 0.0 || textureCoordinate3.y > 1.0){
             v3 = vec4(0.0);
         }
         float alphaMix = v1.a + v3.r - v1.a * v3.r;
         vec3 xColor = vec3(0.0);
         if (alphaMix > 0.001) {
             xColor = (strokeColor.rgb * v3.r + v1.rgb * (1.0 - v3.r)) / alphaMix;
         }
         gl_FragColor = vec4(xColor * alphaMix, alphaMix);
     }
 }